<?php

date_default_timezone_set("America/Sao_Paulo");

require __DIR__."/vendor/autoload.php";
require __DIR__."/vendor/zeedhi/framework/bootstrap.php";
require __DIR__."/vendor/teknisa/libraries/scripts/bootstrap.php";
// require __DIR__."/vendor/teknisa/zeedhiApiKeys/bootstrap.php";

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$instanceManager->loadFromFile(__DIR__."/config/parameters.xml");
$instanceManager->loadFromFile(__DIR__."/config/general.xml");
$instanceManager->loadFromFile(__DIR__."/config/base.xml");
$instanceManager->loadFromFile(__DIR__."/config/factories.xml");
$instanceManager->loadFromFile(__DIR__."/config/services.xml");
$instanceManager->loadFromFile(__DIR__."/config/controllers.xml");
$instanceManager->loadFromFile(__DIR__."/vendor/zeedhi/framework/services.xml");
$instanceManager->loadFromFile(__DIR__."/config/environment.xml");
$instanceManager->loadFromFile(__DIR__."/config/db.xml");
// $instanceManager->loadFromFile(__DIR__."/config/fileServer.xml");

//$instanceManager->loadFromFile(__DIR__."/config/preferences.xml");

$routes = array();
$routes[] = __DIR__ . "/vendor/teknisa/libraries/libRoutes.json";
$routes[] = __DIR__. '/config/routes.json';

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));
$instanceManager->compile();
/*
use Doctrine\DBAL\Types\Type;

Type::overrideType(Type::DATE, 'Setforms2\Shared\ORM\DateType');
Type::overrideType(Type::DATETIME, 'Setforms2\Shared\ORM\DateTimeType');

$entity_manager = $instanceManager->getService('entityManager');
\Setforms2\Shared\Registry::store("EntityManager", $entity_manager);
\Setforms2\Shared\Registry::store("EntityManagerConnection", $entity_manager->getConnection());
*/