<?php
namespace FM\Service;

use FM\Factory\NewLocalAtendimentoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class NewLocalAtendimentoService {
    
    protected $NewLocalAtendimentoFactory;
    protected $Environment;
    protected $newCode;
    
    public function __construct (NewLocalAtendimentoFactory $NewLocalAtendimentoFactory, Environment $Environment, NewCode $newCode) {
        $this->NewLocalAtendimentoFactory  = $NewLocalAtendimentoFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function getServiceLocal(){
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryLocal();
        return $operadores;
    }
    
    public function getServiceLocalParent(){
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryLocalParent();
        return $operadores;
    }
    
    public function getServiceSector(){
        $operadores = $this->NewLocalAtendimentoFactory->getFactorySector();
        return $operadores;
    }
    
    public function getServiceGroup(){
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryGroup();
        return $operadores;
    }
    
    public function getServiceEmployee(){
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryEmployee();
        return $operadores;
    }
    
    public function getServiceCheckList(){
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryCheckList();
        return $operadores;
    }
    
    public function insertServiceLocalAt($nmlocalcliente, $cdcliente, $nrtipolocalcli, $nrlocalclientepai, $nrchecklistpadr, $nrsetor, $dsiconelocal, $dsqrcode, $nrorg, $cdoperinclusao, $nrorginclusao, $cdoperultatu, $nrorgultatu, $nrgrupolocal){
        
        $nrlocalcliente = $this->newCode->getCodeByTableName('FCM_LOCALCLI', $nrorg, 1, 10, true);
        
        $params = array(
            'NRLOCALCLIENTE' => $nrlocalcliente,
            'NMLOCALCLIENTE' => $nmlocalcliente, 
            'CDCLIENTE' => $cdcliente, 
            'NRTIPOLOCALCLI' => $nrtipolocalcli, 
            'NRLOCALCLIENTEPAI' => $nrlocalclientepai, 
            'NRCHECKLISTPADR' => $nrchecklistpadr,
            'NRSETOR' => $nrsetor, 
            'DSICONELOCAL' => $dsiconelocal, 
            'DSQRCODE' => $dsqrcode, 
            'NRORG' => $nrorg,
            'CDOPERINCLUSAO' => $cdoperinclusao,
            'NRORGINCLUSAO' => $nrorginclusao,
            'CDOPERULTATU' => $cdoperultatu, 
            'NRORGULTATU' => $nrorgultatu,          
            'NRGRUPOLOCAL' => $nrgrupolocal
        );
        
        $operadores = $this->NewLocalAtendimentoFactory->insertFactoryLocalAt($params);
        return $operadores;
    }
    
    public function insertServiceTask($nrchecklistagend, $nrfuncionario, $dsobstarefaagend, $nrorg, $cdoperinclusao, $nrorginclusao,  $dtultatu, $cdoperultatu, $nrorgultatu){
        
        $nrtarefaagend = $this->newCode->getCodeByTableName('FCM_LOCALCLI', $nrorg, 1, 10, true);
        
        $params = array(
            'NRTAREFAAGEND' => $nrtarefaagend,
            'NRCHECKLISTAGEND' => $nrchecklistagend,
            'NRFUNCIONARIO' => $nrfuncionario,
            'DSOBSTAREFAAGEND' => $dsobstarefaagend, 
            'NRORG' => $nrorg, 
            'CDOPERINCLUSAO' => $cdoperinclusao, 
            'NRORGINCLUSAO' => $nrorginclusao,  
            'DTULTATU' => $dtultatu, 
            'CDOPERULTATU' => $cdoperultatu, 
            'NRORGULTATU' => $nrorgultatu,
            'NRTAREFACHK' => $nrtarefaagend
        );
        
        $operadores = $this->NewLocalAtendimentoFactory->insertFactoryLocalAt($params);
        return $operadores;
    }
    
    public function getServiceLocalAtToUpdate($nrlocalcliente){
        $param = array(
            'NRLOCALCLIENTE' => $nrlocalcliente
        );
        
        $operadores = $this->NewLocalAtendimentoFactory->getFactoryLocalAtToUpdate($param);
        return $operadores;
    }
    
    public function updateServiceLocalAt($nrlocalcliente, $nmlocalcliente, $nrtipolocalcli, $nrlocalclientepai, $nrchecklistpadr, $nrsetor){
        
        $param = array(
            'NRLOCALCLIENTE' => $nrlocalcliente,
            'NMLOCALCLIENTE' => $nmlocalcliente, 
            'NRTIPOLOCALCLI' => $nrtipolocalcli, 
            'NRLOCALCLIENTEPAI' => $nrlocalclientepai,
            'NRCHECKLISTPADR' => $nrchecklistpadr,
            'NRSETOR' => $nrsetor
        );
        
        $operadores = $this->NewLocalAtendimentoFactory->updateFactoryLocalAt($param);
        return $operadores;
    }
    // Busca todos os locais
    public function getLocals() {
        $operadores = $this->NewLocalAtendimentoFactory->getLocals();
        return $operadores;
    }
}
?>