<?php
namespace FM\Service;

use FM\Factory\VistoriasFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class VistoriasService {
    
    protected $VistoriasFactory;
    protected $Environment;
    protected $newCode;
    
    public function __construct (VistoriasFactory $VistoriasFactory, Environment $Environment, NewCode $newCode) {
        $this->VistoriasFactory  = $VistoriasFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    // Busca nome e local da vistoria
    public function getInspectionNameAndLocal($params) {
        $operators = $this->VistoriasFactory->getInspectionNameAndLocal($params);
        return $operators;
    }
    // Busca e filtra vistorias
    public function getInspectionsInfo($param){
        $filter = array();
        
        forEach($param as $ind => $data){
            if($ind == 'TO_CHAR(A.DTHORAAGEND,\'DD/MM/YYYY\')'){
                (strlen($data) == 21) ? $filter[] = $ind.' = '.$data : '';
            }
            else {
                ($data != null) ? $filter[] = $ind.' = '.$data : '';
            }
        }
        
        if (count($filter) > 0){
            $params = array(
                "FILTER"   => "WHERE ".implode(' and ', $filter)
            );
        }
        else {
            $params = array(
                "FILTER"   => ''
            );
        }
        
        $operators = $this->VistoriasFactory->getInspectionsInfo($params);
        return $operators;
    }
    
    // Busca os critérios
    public function getCriteria($params) {
        $operators = $this->VistoriasFactory->getCriteria($params);
        return $operators;
    }
    
    // Busca as informações da vistoria
    public function getInspectionToUpdate($nrgerenciamentochk, $nratividadechk) {
        $param = array (
            'NRGERENCIAMENTOCHK' => $nrgerenciamentochk,
            'NRATIVIDADECHK' => $nratividadechk
        );
        
        $operators = $this->VistoriasFactory->getInspectionToUpdate($param);
        return $operators;
    }
    
    // Edita a vistoria
    public function updateInspection($nrgerenciamentochk, $nrcriteriotargerchk, $nrcriteriotargerchks, $nrtarefagerchk, $dsobstarefagerchk, $nratividadechk) {
        
        forEach($nrcriteriotargerchk as $id) {
            $cont = 0;
            $cont2 = 0;
            if($id['value'] == null || $id['value'] == ''){
                
                $nrcriteriotargerchk2 = $this->newCode->getCodeByTableName('FCM_CRITERIOTARGERCHK', 20, 1, 10, true);
                
                $params = array (
                    'NRCRITERIOTARGERCHK' => $nrcriteriotargerchk2,
                    'NMCRITERIOTARGERCHK' => $id['name'],
                    'NRTAREFAGERCHK' => $nrtarefagerchk
                );

                $this->VistoriasFactory->insertCriterio($params);
                
            } else {
                forEach($nrcriteriotargerchks as $criterioId) {
                    if($id['value'] == $criterioId){ 
                        //update alterando idmarcado para S incrementa o cont
                        $paramsUpdt = array(
                            'NRCRITERIOTARGERCHK' => $id['value'],
                            'NRTAREFAGERCHK' => $nrtarefagerchk,
                            'IDMARCADO' => 'S'
                        
                        );
                        $this->VistoriasFactory->updateCriterio($paramsUpdt);
                        $cont++;
                    }
                }
                if($cont == 0 ){
                    //update alterando idmarcado para N incrementa
                    $paramsUpdt2 = array(
                        'NRCRITERIOTARGERCHK' => $id['value'],
                        'NRTAREFAGERCHK' => $nrtarefagerchk,
                        'IDMARCADO' => 'N'
                        
                    );
                    $cont2++;
                    $this->VistoriasFactory->updateCriterio($paramsUpdt2);
                }
            }
        }
        
        $paramsUpdtNote = array(
            'NRGERENCIAMENTOCHK' => $nrgerenciamentochk, 
            'NRTAREFAGERCHK' => $nrtarefagerchk, 
            'DSOBSTAREFAGERCHK' => $dsobstarefagerchk
        );
        
        $this->VistoriasFactory->updateNote($paramsUpdtNote);
        
        // $operators = $this->VistoriasFactory->updateFCM_FOTOTAREFAGERCHK($param);
        // $operators = $this->VistoriasFactory->updateFCM_GERENCIAMENTOCHK($param);
    }
    
    // Busca as atividades da vistoria
    public function getActivities($id) {

        $operators = $this->VistoriasFactory->getActivities($id);
        return $operators;
    }
    
    
    // Baixa do fileServe o arquivo de documento e salva em uma pasta temporária
    public function downloadDocFileServer($nrseqmoddocfct, $nrorg) {
        $result = array();
        $params = array(
            "NRSEQMODDOCFCT" => $nrseqmoddocfct,
            "NRORG"          => $nrorg
        );

        $documento = $this->modeloDocFactory->getDocumento($params);
        if(count($documento) > 0) {
            $microtime = microtime(true);
            $microtime = str_replace(".", "_", $microtime);
            
            $documento = $documento[0];
            $fileDir   = $this->fileServerBaseUrl . $documento["DSCAMINHOARQ"];
            $fileName  = $microtime . "_" . str_replace(",", "_", $documento["NMARQUIVO"]);
            
            $fileDirTemp = $this->FileServerService->downloadDocFileServer($fileDir, $fileName, $nrorg);
            $fileName    = base64_encode($fileName);
            $result = "/downloadArquivo?requestType=Row&row[FILENAME]=" . $fileName . "&row[FILETYPE]=" . $documento["DSTIPO"];
        }
        
        return $result;
    }
    
}
?>