/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_PERCENTIL                                                                                            */
/* Tabela : PERCENTIL                                                                                                                    */
/*                                                                                                                                                        */
/* Criao:                                                                                                                                          */
/* 28/10/2004 - Rafael dos Santos Lopes                           			                        */
/*                                                                                                                                                        */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PERCENTIL
BEFORE INSERT OR UPDATE OR DELETE
ON PERCENTIL FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPERC := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMPERCENTIL,0) <> NVL(:NEW.NMPERCENTIL,0)) THEN
         :NEW.DTULTATUPERC := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PERCENTIL', '', 'CDPERCENTIL='||:OLD.CDPERCENTIL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PERCENTIL MODIFY DTULTATUPERC DEFAULT SYSDATE
/

