import { AlertService, Form } from '@zeedhi/common';
import {
  Http, IDictionary, Metadata, Router,
} from '@zeedhi/core';

export class LoginController {
  public logar() {
    if (Metadata.getInstance<Form>('login-form').validate()) {
      Http.post('/validaLogin', Metadata.getInstance<Form>('login-form').value).then((response: IDictionary) => {
        if (response.data.dataset.func.length) {
          this.setUser(response.data.dataset.func[0].NRFUNCIONARIO);
        } else {
          this.loginFail();
        }
      });
    }
  }

  public setUser(nr: number) {
    window.localStorage.setItem('UserLogado', String(nr));
    Router.replace('/');
  }

  public loginFail() {
    AlertService.show({
      name: 'basic-alert',
      text: 'Login ou senha invalida!',
      top: true,
      left: false,
      timeout: 3000,
      color: 'error',
    });
  }

  public delet() {
    window.localStorage.clear();
    Router.replace('/Login');
  }
}
